'use strict';const changesUtils=require('./changes-utils');describe('ChangesUtils',()=>{let a,b,c,d,e,f;beforeAll((a)=>{f=YUI(GlobalConfig).use(['environment-change-set','juju-models'],function(b){e=b.namespace('juju.models'),c=b.namespace('juju').EnvironmentChangeSet,a()})}),beforeEach(()=>{a=[],b=new e.Database({getECS:()=>d}),d=new c({db:b})}),afterEach(()=>{a.forEach((a)=>a()),a=null,window.clearTimeout(d.descriptionTimer),d.destroy()});const g=(a)=>{a.services.add({id:'django',charm:'cs:trusty/django-1',icon:'django.svg'}),a.addUnits({id:'django/0'})};describe('getServiceByUnitId',()=>{it('returns the service',()=>{g(b);const a=changesUtils.getServiceByUnitId('django/0',b.services,b.units);assert.strictEqual(a.get('id'),'django')}),it('raises an error if the service is not found',()=>{assert.throw(()=>{changesUtils.getServiceByUnitId('no-such/42',b.services,b.units)},'unit no-such/42 not found')})}),it('can convert relation endpoints to their real names',()=>{let a=new f.ModelList;a.add([{id:'foobar'},{id:'84882221$',name:'mysql'},{id:'wordpress',name:'wordpress'}]),a=changesUtils.getRealRelationEndpointNames([['wordpress',{name:'db',role:'server'}],['84882221$',{name:'db',role:'client'}],()=>{}],a),assert.deepEqual(a,['mysql','wordpress'])}),it('can generate descriptions and commands for any change type',()=>{g(b),b.services.add({charm:'cs:trusty/apache2-1',icon:'apache2.svg',id:'apache2',name:'apache2-master'});const c=sinon.stub(changesUtils,'getRealRelationEndpointNames').returns(['foo','baz']);a.push(c.restore),[{icon:'django.svg',msg:' cs:trusty/django-1 will be added to the controller.',change:{command:{method:'_addCharm',args:['cs:trusty/django-1','cookies are better'],options:{applicationId:'django'}}}},{icon:'django.svg',msg:' django resources will be added.',change:{command:{method:'_addPendingResources',args:[{applicationName:'django',charmURL:'cs:trusty/django-1'}]}}},{command:'juju deploy cs:trusty/django-1',icon:'django.svg',msg:' django will be added to the model.',change:{command:{method:'_deploy',args:['cs:trusty/django-1','django'],options:{modelId:'django'}}},time:'12:34 PM'},{command:'juju deploy cs:trusty/apache2-1 apache2-master',icon:'apache2.svg',msg:' apache2-master will be added to the model.',change:{command:{method:'_deploy',args:['cs:trusty/apache2-1','apache2'],options:{modelId:'apache2'}}},time:'12:34 PM'},{command:'juju add-unit -n 1 django',icon:'changes-units-added',msg:' 1 django unit will be added.',change:{command:{method:'_add_unit',args:['django',1],options:{modelId:'django/0'}}}},{command:'juju remove-unit foo/0',icon:'changes-units-removed',msg:'1 unit will be removed from foo',change:{command:{method:'_remove_units',args:[['foo/0']]}}},{command:'juju add-unit -n 2 django',icon:'changes-units-added',msg:' 2 django units will be added.',change:{command:{method:'_add_unit',args:['django',2],options:{modelId:'django/0'}}}},{command:'juju relate foo baz',icon:'changes-relation-added',msg:'bar relation will be added between foo and baz.',change:{command:{method:'_add_relation',args:[['foo',{name:'bar'}],['baz']]}}},{command:'juju add-machine -n 1',icon:'changes-container-created',msg:'1 container will be added.',change:{command:{method:'_addMachines',args:[[{constraints:{},parentId:1}]]}}},{command:'juju add-machine -n 2',icon:'changes-container-created',msg:'2 containers will be added.',change:{command:{method:'_addMachines',args:[[{constraints:{},parentId:1},{constraints:{},parentId:1}]]}}},{command:'juju add-machine -n 1',icon:'changes-machine-created',msg:'1 machine will be added.',change:{command:{method:'_addMachines',args:[[{}]]}}},{command:'juju add-machine -n 2',icon:'changes-machine-created',msg:'2 machines will be added.',change:{command:{method:'_addMachines',args:[[{},{}]]}}},{command:'juju config django one="" two=two three=3 four=null',icon:'changes-config-changed',msg:'Configuration values will be changed for django.',change:{command:{method:'_set_config',args:['django',{one:'',two:'two',three:3,four:null,five:void 0}]}}},{icon:'changes-unknown',msg:'An unknown change has been made to this model via the CLI.',change:{command:{method:'_anUnknownMethod'}}}].forEach((a)=>{const c=changesUtils.generateChangeDescription(b.services,b.units,a.change,!0);assert.equal(c.icon,a.icon),assert.equal(c.description,a.msg),assert.equal(c.command,a.command),a.timestamp?assert.equal(c.time,a.time):assert.equal(c.time,'-')})}),it('can generate descriptions for all the changes in the ecs',()=>{const c=sinon.stub(changesUtils,'generateChangeDescription');a.push(c.restore),d.changeSet={foo:{index:0},bar:{index:0}},changesUtils.generateAllChangeDescriptions(b.services,b.units,d.changeSet),assert.equal(c.callCount,2)}),it('can get the counts of each type of ecs change',()=>{assert.deepEqual(changesUtils.getChangeCounts({one:{command:{method:'addMachine'}},two:{command:{method:'addUnit'}},three:{command:{method:'addMachine'}}}),{addMachine:2,addUnit:1,total:3})}),it('can group the ecs change by type',()=>{assert.deepEqual(changesUtils.getGroupedChanges({one:{command:{method:'addMachine'}},two:{command:{method:'addUnit'}},three:{command:{method:'addMachine'}}}),{addUnit:{two:{command:{method:'addUnit'}}},addMachine:{one:{command:{method:'addMachine'}},three:{command:{method:'addMachine'}}}})}),it('can filter the changeset by parent',()=>{assert.deepEqual(changesUtils.filterByParent({one:{parents:['parent1']},two:{parents:['parent2']},three:{parents:['parent1','parent2']}},'parent1'),{one:{parents:['parent1']},three:{parents:['parent1','parent2']}})}),describe('sortDescriptionsByApplication',()=>{const a=sinon.stub();it('sorts additive descriptions by application',()=>{const b=JSON.parse('[{"id":"addPendingResources-458","icon":"https://api.jujucharms.com/charmstore/v5/~containers/easyrsa-12/icon.svg","description":" easyrsa resources will be added.","time":"8:49 am"},{"id":"service-220","icon":"https://api.jujucharms.com/charmstore/v5/~containers/kubernetes-master-35/icon.svg","description":" kubernetes-master will be added to the model.","time":"8:49 am"},{"id":"expose-102","icon":"exposed_16","description":"kubernetes-master will be exposed","time":"8:49 am"},{"id":"addRelation-83","icon":"changes-relation-added","description":"kube-api-endpoint relation will be added between kubernetes-master and kubernetes-worker.","time":"8:49 am"},{"id":"addUnits-256","icon":"changes-units-added","description":" 1 easyrsa unit will be added.","time":"8:49 am"}]'),c=changesUtils.sortDescriptionsByApplication(a,{"addPendingResources-458":{command:{method:'_addPendingResources',args:[{applicationName:'easyrsa'}]}},"service-220":{command:{method:'_deploy',args:[{applicationName:'kubernetes-master'}]}},"expose-102":{command:{method:'_expose',args:['kubernetes-master']}},"addRelation-83":{command:{method:'_add_relation',args:[['kubernetes-worker'],['kubernetes-master']]}},"addUnits-256":{command:{method:'_add_unit',args:['easyrsa']}}},b);assert.deepEqual(c,{easyrsa:[{id:'addPendingResources-458',icon:'https://api.jujucharms.com/charmstore/v5/~containers/easyrsa-12/icon.svg',description:' easyrsa resources will be added.',time:'8:49 am'},{id:'addUnits-256',icon:'changes-units-added',description:' 1 easyrsa unit will be added.',time:'8:49 am'}],"kubernetes-master":[{id:'service-220',icon:'https://api.jujucharms.com/charmstore/v5/~containers/kubernetes-master-35/icon.svg',description:' kubernetes-master will be added to the model.',time:'8:49 am'},{id:'expose-102',icon:'exposed_16',description:'kubernetes-master will be exposed',time:'8:49 am'},{id:'addRelation-83',icon:'changes-relation-added',description:'kube-api-endpoint relation will be added between kubernetes-master and kubernetes-worker.',time:'8:49 am'}],"kubernetes-worker":[{id:'addRelation-83',icon:'changes-relation-added',description:'kube-api-endpoint relation will be added between kubernetes-master and kubernetes-worker.',time:'8:49 am'}]})}),it('skips methods in the blacklist',()=>{const b=changesUtils.sortDescriptionsByApplication(a,{},[{id:'addCharm-123'},{id:'addMachines-123'},{id:'addSSHKeys-123'},{id:'importSSHKeys-123'},{id:'destroyMachines-123'}]);assert.deepEqual(b,{})}),it('does not error for removal commands',()=>{const b=[JSON.parse('{"id":"removeUnit-376","icon":"changes-units-removed","description":"1 unit will be removed from elasticsearch","time":"3:18 pm"}'),JSON.parse('{"id":"removeRelation-281","icon":"changes-relation-removed","description":"rest relation will be removed between kibana and elasticsearch.","time":"3:21 pm"}')],c=changesUtils.sortDescriptionsByApplication(a,{"removeUnit-376":{command:{method:'_remove_units',args:[['elasticsearch/0']]}},"removeRelation-281":{command:{method:'_remove_relation',args:[['kibana'],['elasticsearch']]}}},b);assert.deepEqual(c,{elasticsearch:[{id:'removeUnit-376',icon:'changes-units-removed',description:'1 unit will be removed from elasticsearch',time:'3:18 pm'},{id:'removeRelation-281',icon:'changes-relation-removed',description:'rest relation will be removed between kibana and elasticsearch.',time:'3:21 pm'}],kibana:[{id:'removeRelation-281',icon:'changes-relation-removed',description:'rest relation will be removed between kibana and elasticsearch.',time:'3:21 pm'}]})})})});